﻿#pragma once

#pragma once

#include <SFML/Graphics.hpp>
#include <memory>
#include <cigui/core/View.hpp>
#include <cigui/core/RenderCall.hpp>


namespace cig {

	class Renderer {
	public:
		explicit Renderer(View *_view) : view(_view) { view->draw(); }

		std::unique_ptr<View> view;

		void update() const {
			if (view->update())
				view->draw();
		}

		void render(sf::RenderTarget &target, const sf::RenderStates &states) const {
			auto lambda = [&target, &states](const RenderCall& renderCall) { renderCall.draw(target, states); };
			view->renderCalls().iterate(lambda);
		}
	};
}
